"""Add delete marker to workflow execution

Revision ID: fa96f749a787
Revises: 2dfdf90504a0
Create Date: 2024-07-22 14:42:37.108220

"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision: str = "fa96f749a787"
down_revision: str | None = "2dfdf90504a0"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("workflow_execution", sa.Column("deleted", sa.Boolean(), nullable=False))
    op.alter_column("workflow_execution", "executor_id", existing_type=sa.BINARY(length=16), nullable=True)
    op.drop_constraint("workflow_execution_ibfk_1", "workflow_execution", type_="foreignkey")
    op.create_foreign_key(
        "workflow_execution_ibfk_1", "workflow_execution", "user", ["executor_id"], ["uid"], ondelete="SET NULL"
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("workflow_execution_ibfk_1", "workflow_execution", type_="foreignkey")
    op.create_foreign_key(
        "workflow_execution_ibfk_1", "workflow_execution", "user", ["executor_id"], ["uid"], ondelete="CASCADE"
    )
    op.alter_column("workflow_execution", "executor_id", existing_type=sa.BINARY(length=16), nullable=False)
    op.drop_column("workflow_execution", "deleted")
    # ### end Alembic commands ###
